// trade
import { StoredResource } from '../trade/resource-storage';
/* SINGLE POPULATION CLASS */
var SinglePopulationClass = /** @class */ (function () {
    function SinglePopulationClass(level, name, iconName, consumesResourcesStr, taxes, upgradeResStr) {
        this.taxRate = .2;
        this.iconName = "trader";
        // consumption & upgrade resources
        this.consumesResources = [];
        this.upgradeResource = null;
        this.level = level;
        this.name = name;
        if (taxes) {
            this.taxRate = taxes;
        }
        // icon
        this.iconName = iconName;
        this.setConsumedResourcesFromString(consumesResourcesStr);
    }
    /* consumption is for every 10 pops, so it will usually by lower than the given amount */
    SinglePopulationClass.prototype.setConsumedResourcesFromString = function (consumesResourcesStr) {
        var splitted = consumesResourcesStr.split(" ");
        for (var _i = 0, splitted_1 = splitted; _i < splitted_1.length; _i++) {
            var storedResStr = splitted_1[_i];
            var storedRes = StoredResource.fromString(storedResStr);
            this.consumesResources.push(storedRes);
        }
    };
    SinglePopulationClass.prototype.setUpdateResourceFromString = function (upgradeResStr) {
        var upgradeRes = StoredResource.fromString(upgradeResStr);
        this.upgradeResource = upgradeRes;
    };
    SinglePopulationClass.prototype.getConsumedResIds = function () {
        var consumedResIds = [];
        for (var _i = 0, _a = this.consumesResources; _i < _a.length; _i++) {
            var consumedRes = _a[_i];
            consumedResIds.push(consumedRes.resId);
        }
        return consumedResIds;
    };
    SinglePopulationClass.prototype.getResourceConsumption = function (resId) {
        for (var _i = 0, _a = this.consumesResources; _i < _a.length; _i++) {
            var consumedRes = _a[_i];
            if (consumedRes.resId == resId) {
                return consumedRes.amount;
            }
        }
        return 0;
    };
    return SinglePopulationClass;
}());
export { SinglePopulationClass };
/* CONSTANTS */
// popuulation class ids
export var POP_BEGGARS_NUM = 0;
export var POP_PEASANTS_NUM = 1;
export var POP_CITIZEN_NUM = 2;
export var POP_CLERICAL_NUM = 3;
export var POP_MERCHANTS_NUM = 4;
export var POP_NOBLES_NUM = 5;
// SinglePopulationClass object definitions
export var POP_CLASSES = [
    new SinglePopulationClass(POP_BEGGARS_NUM, "Beggars", "beggar", "0.3xale 0.3xfish 1xwood", .5, "0.5xtools"),
    new SinglePopulationClass(POP_PEASANTS_NUM, "Peasants", "peasant", "0.4xgrain 0.3xfish 0.2xale", 2, "0.4xtools"),
    new SinglePopulationClass(POP_CITIZEN_NUM, "Citizen", "citizen", "0.5xgrain 0.3xpelts 0.2xale", 1.5, "0.2xclothes"),
    new SinglePopulationClass(POP_CLERICAL_NUM, "Clerical", "clerical", "0.4xale 0.2xclothes 0.1xpearls", 2, "0.2xgold"),
    new SinglePopulationClass(POP_MERCHANTS_NUM, "Merchants", "trader", "0.7xgrain 0.2xclothes 0.2xtools 0.2xpearls", 3.3, "0.4xgold"),
    new SinglePopulationClass(POP_NOBLES_NUM, "Nobles", "noble", "1xgrain 0.3xgold 0.5xclothes 0.1xweapons", 4)
];
//# sourceMappingURL=population-class.js.map