/* == MARKET TRADE MODEL == */
var MarketTrade = /** @class */ (function () {
    function MarketTrade(turn, resId, profit, target, source, marketOverride) {
        this.isExport = false;
        this.turn = turn;
        this.resId = resId;
        this.profit = profit;
        // source & target cities
        if (source) {
            this.source = source;
            this.market = source.tradeNode;
            if (target) {
                this.target = target;
            }
        }
        if (marketOverride) {
            this.market = marketOverride;
        }
    }
    Object.defineProperty(MarketTrade.prototype, "fromToStr", {
        /* GETTER METHODS */
        get: function () {
            if (this.isExport) {
                return "t.";
            }
            return "f.";
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarketTrade.prototype, "iconName", {
        get: function () {
            if (this.isExport) {
                return "export";
            }
            return "import";
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarketTrade.prototype, "plusMinusStr", {
        get: function () {
            if (this.isExport) {
                return "+";
            }
            return "-";
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarketTrade.prototype, "otherLocation", {
        get: function () {
            if (this.isExport) {
                return this.target;
            }
            return this.source;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarketTrade.prototype, "otherLocationName", {
        get: function () {
            if (this.otherLocation) {
                return this.otherLocation.name;
            }
            return "nowhere";
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarketTrade.prototype, "absProfitModifier", {
        get: function () {
            if (!this.isExport) {
                return -1;
            }
            return 1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarketTrade.prototype, "absProfit", {
        get: function () {
            return this.profit * this.absProfitModifier;
        },
        enumerable: false,
        configurable: true
    });
    return MarketTrade;
}());
export { MarketTrade };
//# sourceMappingURL=market-trade.js.map