var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// common 
import { Loggable } from "../../../../common/log";
// world 
import { TerrainTypes } from "../../../world/tile/tile-terrain";
/* == MOUNT MODEL == */
var UnitMount = /** @class */ (function (_super) {
    __extends(UnitMount, _super);
    function UnitMount(isLand, baseHealth, baseMovement, modifiersStr, baseCargoSpace) {
        var _this = _super.call(this, "UnitMount") || this;
        _this.baseMovement = 2;
        _this.baseCargoSpace = 0;
        _this.baseHealth = 4;
        _this.moveModifiers = [];
        _this.isLand = isLand;
        _this.baseHealth = baseHealth;
        _this.baseMovement = baseMovement;
        _this.modifiersStr = modifiersStr;
        _this.moveModifiers = UnitMount.TerrainModsFromString(modifiersStr);
        if (baseCargoSpace) {
            _this.baseCargoSpace = baseCargoSpace;
        }
        // assign cat
        _this.assignMountCategory();
        return _this;
    }
    UnitMount.prototype.assignMountCategory = function () {
        this.mountCatNum = MOUNT_CAT_INF;
        if (!this.id) {
            return;
        }
        // vehicle?
        if (this.id.includes("ship")) {
            this.mountCatNum = MOUNT_CAT_VEH;
        }
        else if (this.id.includes("vehicle")) {
            this.mountCatNum = MOUNT_CAT_VEH;
        }
        // or cavalry?
        else if (this.baseMovement > 3) {
            this.mountCatNum = MOUNT_CAT_CAV;
        }
    };
    UnitMount.TerrainModsFromString = function (modifiersStr) {
        var modifiers = [];
        var splitted = modifiersStr.split(" ");
        for (var _i = 0, splitted_1 = splitted; _i < splitted_1.length; _i++) {
            var modifierStr = splitted_1[_i];
            var singleModifier = UnitMovementModifier.FromString(modifierStr);
            modifiers.push(singleModifier);
        }
        return modifiers;
    };
    Object.defineProperty(UnitMount.prototype, "isInfantry", {
        /* FLAGS */
        get: function () { return this.mountCatNum == MOUNT_CAT_INF; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(UnitMount.prototype, "isVehicle", {
        get: function () { return this.mountCatNum == MOUNT_CAT_VEH; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(UnitMount.prototype, "isShip", {
        get: function () {
            return this.mountCatNum == MOUNT_CAT_VEH && !(this.isLand);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(UnitMount.prototype, "isLandVehicle", {
        get: function () {
            return this.mountCatNum == MOUNT_CAT_VEH && this.isLand;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(UnitMount.prototype, "isCavalry", {
        get: function () { return this.mountCatNum == MOUNT_CAT_INF; },
        enumerable: false,
        configurable: true
    });
    return UnitMount;
}(Loggable));
export { UnitMount };
/* == MOVEMENT MODIFIER MODEL == */
var UnitMovementModifier = /** @class */ (function () {
    function UnitMovementModifier(terrainId, percent) {
        this.terrainId = terrainId;
        this.movementPercent = percent;
        this.modifier = percent / 100;
    }
    UnitMovementModifier.FromString = function (singleModifierStr) {
        return null;
    };
    return UnitMovementModifier;
}());
export { UnitMovementModifier };
/* == MOVE TYPE LIST == */
var UnitMovementTypes = /** @class */ (function () {
    function UnitMovementTypes() {
    }
    return UnitMovementTypes;
}());
export { UnitMovementTypes };
function getTerrainTypes() {
    return TerrainTypes.LIST;
}
/* == CONSTANTS == */
// categories
export var MOUNT_CAT_INF = 0;
export var MOUNT_CAT_CAV = 1;
export var MOUNT_CAT_VEH = 2;
export var MOUNT_CAT_NAMES = ["Infantry", "Cavalry", "Vehicle"];
// movement modifier strings
export var MOVEMOD_DECR1 = "-";
export var MOVEMOD_DECR2 = "--";
export var MOVEMOD_ZERO = "0";
export var MOVEMOD_INCR1 = "+";
export var MOVEMOD_INCR2 = "++";
// mount movement modifiers
export var MOVEMOD_STR_DEFAULT = "M- F- D- S- W0";
export var MOVEMOD_STR_FOOT = MOVEMOD_STR_DEFAULT;
export var MOVEMOD_STR_HORSE = "M-- F-- D- S- W0";
export var MOVEMOD_STR_CAMEL = "M- F-- D+ S- G- W0";
export var MOVEMOD_STR_VEHICLE = "M0 F-- S- W0";
export var MOVEMOD_STR_SHIP = "W+ G0 F0 D0 S0 M0";
// mount json fields
export var JSON_FIELD_MP = "mp";
export var JSON_FIELD_TERRMOD = "terrainModifiers";
//# sourceMappingURL=mount.js.map