// common
import { DawnbringerPalette } from '../../../common/colors';
// gui
import * as GUI_CONST from './constants';
import { GuiLabel } from '../elements/babylon/labels';
var GuiTools = /** @class */ (function () {
    function GuiTools() {
    }
    /* == SIZE SETTERS == */
    GuiTools.setToDefaultSize = function (control) {
        control.width = GUI_CONST.DEFAULT_WIDTH;
        control.height = GUI_CONST.DEFAULT_ELEMENT_HEIGHT;
    };
    GuiTools.setSizeInPx = function (control, width, height) {
        control.widthInPixels = width;
        control.heightInPixels = height;
    };
    GuiTools.setSizeFrom = function (control, other) {
        control.width = other.width;
        control.height = other.height;
    };
    GuiTools.setFullPadding = function (control, paddingStr) {
        control.paddingLeft = paddingStr;
        control.paddingRight = paddingStr;
        control.paddingTop = paddingStr;
        control.paddingBottom = paddingStr;
    };
    GuiTools.addNewGuiLabel = function (parent, labelId, text, isClickable, hasSmallHeight, hasNoBackground) {
        var labelElem = new GuiLabel(labelId, text, isClickable, hasSmallHeight, hasNoBackground);
        parent.addControl(labelElem);
        return labelElem;
    };
    GuiTools.setAlignments = function (parent, alignmentsNumArray) {
        if (alignmentsNumArray && alignmentsNumArray.length > 1) {
            parent.horizontalAlignment = alignmentsNumArray[0];
            parent.verticalAlignment = alignmentsNumArray[1];
        }
    };
    GuiTools.addNewDivider = function (parent) {
    };
    /* == FONT SETTERS == */
    GuiTools.setDefaultFontStyle = function (control) {
        control.fontSize = GUI_CONST.TEXTSIZE_NORMAL;
        control.fontFamily = GUI_CONST.FONT_HIGHLIGHTED;
    };
    GuiTools.setHighlightedFontColor = function (control) {
        var hexColor = BABYLON.Color3.FromArray(DawnbringerPalette.GOLDENFIZZ).toHexString();
        control.color = hexColor;
    };
    return GuiTools;
}());
export { GuiTools };
//# sourceMappingURL=gui-tools.js.map