var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { GuiElementHead } from './element-head';
import { GuiSize } from './gui-size';
import { GuiTools } from './gui-tools';
import * as GUI from 'babylonjs-gui';
var GuiRectangle = /** @class */ (function (_super) {
    __extends(GuiRectangle, _super);
    function GuiRectangle(controlId, alignments) {
        var _this = _super.call(this, controlId) || this;
        _this.isHovered = false;
        _this.name = controlId;
        // remove outter white border
        _this.thickness = 0;
        // add element head & size object
        _this.size = new GuiSize(_this);
        _this.head = new GuiElementHead(controlId, _this);
        // this.align = new GuiAlignment(this);
        // custom alignment?
        if (alignments && alignments.length > 1) {
            _this.horizontalAlignment = alignments[0];
            _this.verticalAlignment = alignments[1];
        }
        // add observables
        _this.addObservables();
        return _this;
    }
    /* INITIALIZATION */
    GuiRectangle.prototype.addObservables = function (noHover) {
        var __this = this;
        this.onPointerDownObservable.add(function () { __this.onClick(); });
        if (noHover && noHover == true) {
            return;
        }
        // add hover observables
        this.onPointerEnterObservable.add(function () { __this.onHover(); });
        this.onPointerOutObservable.add(function () { __this.onHoverEnd(); });
    };
    /* SET OUTTER SIZE */
    GuiRectangle.prototype.setSizeInPixels = function (width, height) {
        var elemHeight = width;
        if (height) {
            elemHeight = height;
        }
        // set rectangle width & height properties
        this.widthInPixels = width;
        this.heightInPixels = elemHeight;
    };
    /* set outter size as string; per example "12em", "8%", "100px" */
    GuiRectangle.prototype.setSize = function (widthStr, heightStr) {
        var elemHeightStr = widthStr;
        if (heightStr) {
            elemHeightStr = heightStr;
        }
        this.size.set(widthStr, elemHeightStr);
    };
    GuiRectangle.prototype.setToDefaultSize = function () {
        GuiTools.setToDefaultSize(this);
    };
    GuiRectangle.prototype.setFullPadding = function (paddingStr) {
        GuiTools.setFullPadding(this, paddingStr);
    };
    /* SET ALIGNMENT IN PARENT */
    GuiRectangle.prototype.setAlignment = function (horizontal, vertical) {
        this.align.set(horizontal, vertical);
    };
    /* DELETION CLEAN UP */
    GuiRectangle.prototype.dispose = function () {
        // delete head
        this.head.delete();
        this.head = null;
        // delete size & align
        this.size.parent = null;
        this.size = null;
        // this.align.parent = null;
        // this.align = null;
        // dispose babylon control
        _super.prototype.dispose.call(this);
    };
    /* ELEMENT INTERACFTION */
    GuiRectangle.prototype.onClick = function () {
        this.log("clicked!");
        globalThis.GUI.onElementClicked(this.name);
    };
    GuiRectangle.prototype.onHover = function () {
        this.isHovered = true;
    };
    GuiRectangle.prototype.onHoverEnd = function () {
        this.isHovered = false;
    };
    /* LOGGING TO HEADER */
    GuiRectangle.prototype.success = function (message) { this.head.success(message); };
    GuiRectangle.prototype.log = function (message) { this.head.log(message); };
    GuiRectangle.prototype.warn = function (message) { this.head.warn(message); };
    GuiRectangle.prototype.error = function (message) { this.head.error(message); };
    Object.defineProperty(GuiRectangle.prototype, "isMuted", {
        get: function () { return this.head.isMuted; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GuiRectangle.prototype, "logName", {
        get: function () { return this.head.logName; },
        enumerable: false,
        configurable: true
    });
    /* EVENT HANDLING */
    /* events get passed from the element head object */
    GuiRectangle.prototype.onEvent = function (ev) {
        return true;
    };
    return GuiRectangle;
}(GUI.Rectangle));
export { GuiRectangle };
//# sourceMappingURL=rectangle.js.map