var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as EV from "../../game-events";
import { EmptyDialog } from "./common/base-dialog";
import { SingleArmyDialog } from "./army-dialog";
var ArmiesDialog = /** @class */ (function (_super) {
    __extends(ArmiesDialog, _super);
    function ArmiesDialog(pos) {
        var _this = _super.call(this, DIAG_ARMIES, true, "Armies") || this;
        _this.pos = pos;
        _this.armiesAtPos = globalThis.ARMIES.getArmiesAtPos(pos);
        return _this;
    }
    ArmiesDialog.prototype.addCustomContent = function () {
        for (var _i = 0, _a = this.armiesAtPos; _i < _a.length; _i++) {
            var army = _a[_i];
            var keyStr = this.getArmyNameStr(army);
            var valueStr = "".concat(army.units.length, " Units");
            var armyIcon = army.armyTypeIcon;
            this.addNewDataRow(keyStr, valueStr, armyIcon, true);
        }
    };
    ArmiesDialog.prototype.getArmyNameStr = function (army) {
        return "".concat(army.armyTypeName, " (").concat(army.num, ")");
    };
    ArmiesDialog.prototype.getArmyNumByKeyStr = function (datarowKeyStr) {
        // cut off forst part
        var armyNumInvalid = -2;
        var armyNumFullStr = datarowKeyStr.split(" ")[1];
        var armyNumStr = armyNumFullStr.replace("(", "").replace(")", "");
        var armyNum = parseInt(armyNumStr);
        return armyNum;
    };
    /* GUI INTERACTION */
    ArmiesDialog.prototype.onElementClicked = function (elemId) {
        var success = _super.prototype.onElementClicked.call(this, elemId);
        var armyRowKey = elemId.replace("datarow-", "");
        var armyNum = this.getArmyNumByKeyStr(armyRowKey);
        if (armyNum) {
            var army = globalThis.ARMIES.getArmyByNum(armyNum);
            // show single army dialog
            var singleArmyDiag = new SingleArmyDialog(army);
            this.close();
            globalThis.GUI.showDialog(singleArmyDiag);
            return true;
        }
        return false;
    };
    /* EVENT LISTENING */
    ArmiesDialog.prototype.onEvent = function (ev) {
        _super.prototype.onEvent.call(this, ev);
        // ELEMENT CLICKED
        if (ev.id = EV.ID_GUI_ELEM_CLICKED) {
            var clickedElemId = ev.properties.getStr("elemId");
            if (clickedElemId) {
                this.onElementClicked(clickedElemId);
            }
        }
    };
    return ArmiesDialog;
}(EmptyDialog));
export { ArmiesDialog };
export var DIAG_ARMIES = "diag-armies";
//# sourceMappingURL=armies-dialog.js.map