var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// gui
import { EmptyDialog } from "./common/base-dialog";
import { ColorPalette } from "../../../helpers/colorpalette";
/* == CITY CONSUMPTION DIAG MODEL == */
var CityConsumptionDialog = /** @class */ (function (_super) {
    __extends(CityConsumptionDialog, _super);
    function CityConsumptionDialog(city) {
        var _this = _super.call(this, DIAG_CONSUMPTION, false, "".concat(city.name, " Consumption")) || this;
        // set city & classes list
        _this.city = city;
        _this.consumedResIds = city.population.getTotalResConsumptionList();
        return _this;
    }
    CityConsumptionDialog.prototype.addCustomContent = function () {
        this.log("consumed resources: ".concat(this.consumedResIds));
        for (var _i = 0, _a = this.consumedResIds; _i < _a.length; _i++) {
            var resId = _a[_i];
            var consumedResAmount = this.city.population.getTotalResConsumption(resId);
            if (consumedResAmount > 0) {
                var resName = globalThis.TRADE.getResName(resId);
                var datarow = this.addNewDataRow(resName, consumedResAmount.toFixed(2), "storage");
                // text color
                if (!this.city.population.resIsFullySupplied(resId)) {
                    datarow.valueLabel.color = ColorPalette.NameAsHexStr(TEXT_COLOR_RED_NAME);
                }
            } // end of consumption amount heck
        } // end of cunsumed resId loop
    };
    /* EVENT HANDLING */
    CityConsumptionDialog.prototype.onElementClicked = function (elemId) {
        var success = _super.prototype.onElementClicked.call(this, elemId);
        var city = this.city;
        return false;
    };
    return CityConsumptionDialog;
}(EmptyDialog));
export { CityConsumptionDialog };
/* == CONSUMPTION DIALOG CONSTANTS == */
export var DIAG_CONSUMPTION = "diag-consumption";
export var TEXT_COLOR_RED_NAME = "BROWN";
//# sourceMappingURL=city-consumption-dialog.js.map