var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// common
import { ColorPalette } from "../../../../helpers/colorpalette";
import * as GUI_CONST from '../../common/constants';
// babylon
import * as GUI from 'babylonjs-gui';
/* == DIALOG BUTTON CLASS == */
var DialogButton = /** @class */ (function (_super) {
    __extends(DialogButton, _super);
    function DialogButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DialogButton.CreateNew = function (btnId, text, parentDialog) {
        // add button
        var bgImgPath = GUI_CONST.BG_BUTTON1;
        var btn = GUI.Button.CreateImageWithCenterTextButton(btnId, text, bgImgPath);
        // set default style
        DialogButton.AdjustContainer(btn);
        DialogButton.SetFontStyle(btn);
        // add on click listener
        parentDialog.addControl(btn);
        var onClickFunction = function () {
            var btnId = "" + btn.uniqueId;
            if (btn.name) {
                btnId = btn.name;
            }
            parentDialog.onButtonClick(btnId);
        };
        btn.onPointerDownObservable.add(onClickFunction);
        return btn;
    };
    DialogButton.CreateFromProperty = function (strProp, parentDialog) {
        var btnId = strProp.id;
        var btnText = strProp.value;
        return DialogButton.CreateNew(btnId, btnText, parentDialog);
    };
    DialogButton.AdjustContainer = function (btn) {
        btn.thickness = 0;
        btn.width = GUI_CONST.DEFAULT_INNER_WIDTH;
    };
    DialogButton.SetFontStyle = function (btn) {
        btn.fontFamily = GUI_CONST.FONT_HIGHLIGHTED;
        btn.fontSize = GUI_CONST.TEXTSIZE_BIGGER;
        btn.color = ColorPalette.NameAsHexStr(BUTTON_TEXT_COLOR);
    };
    return DialogButton;
}(GUI.Button));
export { DialogButton };
/* == DIALOG BUTTON CONSTANTS == */
export var BUTTON_TEXT_COLOR = "ATLANTIS";
//# sourceMappingURL=dialog-button.js.map