var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { EmptyDialog } from "./common/base-dialog";
/* == DIALOG MODEL == */
var FamilyCaravansDialog = /** @class */ (function (_super) {
    __extends(FamilyCaravansDialog, _super);
    function FamilyCaravansDialog(noPlayerFamilyNum) {
        var _this = _super.call(this, DIAG_FAMILY_CARAVANS, false, "Caravans") || this;
        _this.familyNum = 0;
        if (noPlayerFamilyNum) {
            _this.familyNum = noPlayerFamilyNum;
        }
        return _this;
    }
    FamilyCaravansDialog.prototype.addCustomContent = function () {
        this.addCaravanArmyList();
    };
    FamilyCaravansDialog.prototype.addCaravanArmyList = function () {
        for (var _i = 0, _a = this.familyCaravanArmies; _i < _a.length; _i++) {
            var familyCaravan = _a[_i];
            var elemId = "datarow-Army" + familyCaravan.num;
            this.addNewDataRow("Army", familyCaravan.name, "army", false, elemId);
        }
    };
    Object.defineProperty(FamilyCaravansDialog.prototype, "isForPlayer", {
        get: function () {
            return this.familyNum == 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FamilyCaravansDialog.prototype, "family", {
        get: function () {
            var family = globalThis.FACTIONS.getFamilyByNum(this.familyNum);
            return family;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FamilyCaravansDialog.prototype, "familyCaravanArmies", {
        get: function () {
            var factionKey = "F" + this.familyNum;
            var factionArmies = globalThis.ARMIES.getArmiesByFactionKey(factionKey);
            var factionCaravans = [];
            for (var _i = 0, factionArmies_1 = factionArmies; _i < factionArmies_1.length; _i++) {
                var factionArmy = factionArmies_1[_i];
                if (factionArmy.isCaravan) {
                    factionCaravans.push(factionArmy);
                }
            }
            return factionCaravans;
        },
        enumerable: false,
        configurable: true
    });
    return FamilyCaravansDialog;
}(EmptyDialog));
export { FamilyCaravansDialog };
/* == DIALOG CONSTANTS == */
export var DIAG_FAMILY_CARAVANS = "diag-caravans";
//# sourceMappingURL=family-caravans-dialog.js.map