var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { EmptyDialog } from "./common/base-dialog";
import { SingleArmyDialog } from "./caravan-units-dialog";
/* shows info about the player's caravan once clicked */
var PlayerInfoDialog = /** @class */ (function (_super) {
    __extends(PlayerInfoDialog, _super);
    function PlayerInfoDialog() {
        var _this = _super.call(this, DIAG_PLAYER_INFO, false, "Player") || this;
        _this.playerArmy = globalThis.PLAYER.army;
        return _this;
    }
    PlayerInfoDialog.prototype.build = function () {
        _super.prototype.build.call(this);
    };
    PlayerInfoDialog.prototype.addCustomContent = function () {
        // add labels
        this.addNewDataRow("family", PLAYER.family.name);
        // show stored resources
        this.showResourceInventory();
        // add buttons
        this.addNewButton(DIAG_PLAYER_BTN_INVENTORY, "Inventory");
        this.addNewButton(DIAG_PLAYER_BTN_UNITS, "Units");
    };
    PlayerInfoDialog.prototype.showResourceInventory = function () {
        var storage = globalThis.PLAYER.army.storedResources;
        for (var _i = 0, storage_1 = storage; _i < storage_1.length; _i++) {
            var storedRes = storage_1[_i];
            this.showStoredResRow(storedRes);
        }
    };
    PlayerInfoDialog.prototype.showStoredResRow = function (storedRes) {
        var resName = globalThis.TRADE.getResName(storedRes.resId);
        var resPrice = storedRes.price;
        var elemId = "res-inv-".concat(storedRes.resId);
        this.addNewDataRow(resName, resPrice + "o", "storage", false, elemId);
    };
    /* EVENT HANDLING */
    PlayerInfoDialog.prototype.onButtonClick = function (btnId) {
        if (btnId === DIAG_PLAYER_BTN_INVENTORY) {
            this.log("show inventory diag");
        }
        else if (btnId === DIAG_PLAYER_BTN_UNITS) {
            // show player ArmyDialog
            var armyDiag = new SingleArmyDialog(this.playerArmy);
            globalThis.GUI.showDialog(armyDiag);
        }
    };
    return PlayerInfoDialog;
}(EmptyDialog));
export { PlayerInfoDialog };
export var DIAG_PLAYER_INFO = "diag-player-info";
export var DIAG_PLAYER_BTN_INVENTORY = "diag-player-btn-inventory";
export var DIAG_PLAYER_BTN_UNITS = "diag-player-btn-units";
//# sourceMappingURL=player-dialog.js.map