var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// gui
import * as GUI_CONST from '../../common/constants';
import { GuiTools } from '../../common/gui-tools';
// babylon
import * as GUI from 'babylonjs-gui';
var NarrowIconLabel = /** @class */ (function (_super) {
    __extends(NarrowIconLabel, _super);
    function NarrowIconLabel(elemId, iconName, text) {
        var _this = _super.call(this, elemId) || this;
        _this.name = elemId;
        _this.iconName = iconName;
        _this.text = text;
        // set size
        _this.width = GUI_CONST.NARROW_WIDTH;
        _this.height = GUI_CONST.DEFAULT_LABEL_HEIGHT;
        // create inner elements
        // this._createContainer();
        _this._createContent();
        return _this;
    }
    NarrowIconLabel.prototype._addControl = function (control) {
        control.height = GUI_CONST.DEFAULT_LABEL_HEIGHT;
        _super.prototype.addControl.call(this, control);
    };
    NarrowIconLabel.prototype.addControl = function (control) {
        this.container.addControl(control);
        return this;
    };
    NarrowIconLabel.prototype._createContainer = function () {
        this.container = new GUI.StackPanel("".concat(this.name, "-container"));
        this.container.isVertical = false;
        // size & margin
        this.container.width = this.width;
        this.container.paddingLeftInPixels = MARGIN_PX;
        this.container.paddingRightInPixels = MARGIN_PX;
        this.container.paddingTopInPixels = MARGIN_PX;
        this.container.paddingBottomInPixels = MARGIN_PX;
        this._addControl(this.container);
    };
    NarrowIconLabel.prototype._createContent = function () {
        // create icon
        // create label
    };
    return NarrowIconLabel;
}(GUI.Rectangle));
export { NarrowIconLabel };
var GuiLabel = /** @class */ (function (_super) {
    __extends(GuiLabel, _super);
    function GuiLabel(elemId, text, clickable, smallHeight, noBackground, customAlignments) {
        var _this = _super.call(this, elemId) || this;
        // flags
        _this.isClickable = false;
        _this.hasSmallHeight = false;
        _this.hasNoBackground = false;
        // set basic properties
        GuiTools.setAlignments(_this, customAlignments);
        _this.text = text;
        // set flags
        if (clickable && clickable == true) {
            _this.isClickable = true;
        }
        if (smallHeight && smallHeight == true) {
            _this.hasSmallHeight = true;
        }
        if (noBackground && noBackground == true) {
            _this.hasNoBackground = true;
        }
        // update container && create children
        _this.updateContainer();
        _this.createChildren();
        return _this;
    }
    GuiLabel.prototype.updateContainer = function () {
        this.width = "400px";
        this.height = this.labelHeight;
        this.thickness = 0;
    };
    /* CHILD CREATION METHODS */
    GuiLabel.prototype.createChildren = function () {
        if (!this.hasNoBackground) {
            this.createLabelBackground();
        }
        this.createLabelTextBlock();
        if (this.isClickable) {
            this.makeClickable();
        }
    };
    GuiLabel.prototype.createLabelBackground = function () {
        var bgImageId = this.elemId + "-bg";
        this.labelBg = new GUI.Image(bgImageId, GUI_CONST.BG_PAPER);
        this.labelBg.height = this.labelHeight;
        this.addControl(this.labelBg);
    };
    GuiLabel.prototype.createLabelTextBlock = function () {
        // create TextBlock element
        var textBlockId = this.elemId + "-textblock";
        this.labelTextBlock = new GUI.TextBlock(textBlockId, this.text);
        this.labelTextBlock.height = this.labelHeight;
        // set label font
        this.labelTextBlock.fontSize = GUI_CONST.TEXTSIZE_NORMAL;
        this.labelTextBlock.fontFamily = GUI_CONST.FONT_PARAGRAPH;
        this.addControl(this.labelTextBlock);
    };
    GuiLabel.prototype.makeClickable = function () {
        var _this_ = this;
        this.labelTextBlock.onPointerDownObservable.add(function () {
            var elemId = _this_.name;
            _this_.onElementClicked(elemId);
        });
    };
    Object.defineProperty(GuiLabel.prototype, "labelHeight", {
        /* LABEL GETTERS */
        get: function () {
            if (this.hasSmallHeight) {
                return GUI_CONST.SMALL_LABEL_HEIGHT;
            }
            return GUI_CONST.DEFAULT_LABEL_HEIGHT;
        },
        enumerable: false,
        configurable: true
    });
    /* EVENT HANDLING */
    GuiLabel.prototype.onElementClicked = function (elemId) {
        console.log("<GuiLabel \"".concat(this.name, "\"> clicked!"));
        // inform GuiManager
        globalThis.GUI.onElementClicked(elemId);
    };
    return GuiLabel;
}(GUI.Rectangle));
export { GuiLabel };
//const NARROW_ICON_SIZE_PX = 31;
var MARGIN_PX = 2;
var INNER_HEIGHT_PX = GUI_CONST.DEFAULT_LABEL_HEIGHT_PX - 2 * (MARGIN_PX);
//# sourceMappingURL=labels.js.map