var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// gui
import * as GUI_CONST from '../common/constants';
import { GuiRectangle } from '../common/rectangle';
import { GuiTools } from '../common/gui-tools';
// babylon
import * as GUI from 'babylonjs-gui';
import { InlineIcon } from './icons';
/* == GUI CHECKBOX ELEMENT == */
var GuiCheckBox = /** @class */ (function (_super) {
    __extends(GuiCheckBox, _super);
    function GuiCheckBox(elemId, text, isChecked, isMultiple) {
        var _this = _super.call(this, elemId) || this;
        _this.text = "";
        _this._isChecked = false;
        _this.isMultiple = false;
        // default properties
        _this.text = text;
        // optional properties
        if (isChecked) {
            _this._isChecked = true;
        }
        if (isMultiple) {
            _this.isMultiple = true;
        }
        // update size & create children
        _this.createChildren();
        _this.adjustSize();
        _this.update();
        return _this;
    }
    GuiCheckBox.prototype.adjustSize = function () {
        this.height = GUI_CONST.DEFAULT_LABEL_HEIGHT;
    };
    Object.defineProperty(GuiCheckBox.prototype, "isChecked", {
        get: function () { return this._isChecked; },
        set: function (isChecked) {
            this._isChecked = isChecked;
            this.update();
        },
        enumerable: false,
        configurable: true
    });
    GuiCheckBox.prototype.createBackground = function () {
        var bgImageId = this.name + "-bg";
        this.checkboxBg = new GUI.Image(bgImageId, GUI_CONST.BG_PAPER);
        this.checkboxBg.height = GUI_CONST.DEFAULT_LABEL_HEIGHT;
        this.checkboxBg.width = GUI_CONST.DEFAULT_INNER_WIDTH;
        this.addControl(this.checkboxBg);
    };
    GuiCheckBox.prototype.createInnerLayout = function () {
        var innerLayoutId = this.name + "-layout";
        this.innerLayout = new GUI.StackPanel(innerLayoutId);
        this.innerLayout.height = GUI_CONST.DEFAULT_LABEL_HEIGHT;
        this.innerLayout.horizontalAlignment = GUI_CONST.ALIGN_H_CENTER;
        this.innerLayout.isVertical = false;
        this.addControl(this.innerLayout);
    };
    GuiCheckBox.prototype.createCheckboxIcon = function () {
        var inlineIconId = this.name + "-icon";
        var iconName = "checkbox_0";
        if (this._isChecked) {
            iconName = "checkbox_1";
        }
        this.checkboxIcon = new InlineIcon(inlineIconId, iconName);
        this.checkboxIcon.width = CHECKB_ICON_WIDTH_OUTTER;
        this.checkboxIcon.height = GUI_CONST.DEFAULT_LABEL_HEIGHT;
        this.innerLayout.addControl(this.checkboxIcon);
    };
    GuiCheckBox.prototype.createCheckboxLabel = function () {
        this.checkboxLabel = GuiTools.addNewGuiLabel(this.innerLayout, this.ID_LABEL, this.text, true, true);
        this.checkboxLabel.width = CHECKB_LABEL_WIDTH;
        this.checkboxLabel.labelTextBlock.textHorizontalAlignment = GUI_CONST.ALIGN_TEXT_H_LEFT;
    };
    GuiCheckBox.prototype.createChildren = function () {
        // create background
        this.createBackground();
        // create inner layout
        this.createInnerLayout();
        // create icon
        this.createCheckboxIcon();
        // create text label
        this.createCheckboxLabel();
    };
    /* CHILD UPDATE METHODS */
    GuiCheckBox.prototype.update = function () {
        // update icon
        this.checkboxIcon.setIconImage(this.iconName);
    };
    Object.defineProperty(GuiCheckBox.prototype, "iconName", {
        /* GETTER METHODS */
        get: function () {
            return GuiCheckBox.GetIconNameFromChecked(this.isChecked);
        },
        enumerable: false,
        configurable: true
    });
    /* STATIC GETTERS */
    GuiCheckBox.GetIconNameFromChecked = function (isChecked) {
        var checkedUncheckedNum = 0;
        if (isChecked) {
            checkedUncheckedNum = 1;
        }
        ;
        return CHECKB_ICON_PREFIX + checkedUncheckedNum;
    };
    Object.defineProperty(GuiCheckBox.prototype, "ID_LABEL", {
        get: function () { return this.name + "cb-label"; },
        enumerable: false,
        configurable: true
    });
    return GuiCheckBox;
}(GuiRectangle));
export { GuiCheckBox };
/* == GUI CHECKBOX CONSTANTS == */
export var CHECKB_ICON_PREFIX = "checkbox_";
export var CHECKB_ICON_WIDTH_OUTTER = "50px";
export var CHECKB_LABEL_WIDTH = "350px";
//# sourceMappingURL=checkbox.js.map