var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// gui
import * as GUI_CONST from '../../common/constants';
import { AbstractMenu } from './abstract-menu';
// babylon
import * as GUI from 'babylonjs-gui';
var SideBarMenu = /** @class */ (function (_super) {
    __extends(SideBarMenu, _super);
    function SideBarMenu(menuId, isHorizontal, isRightOrBottom) {
        var _this = _super.call(this, menuId) || this;
        // default axis: y (top or bottom)
        _this.axisNum = SIDEBAR_AXIS_Y;
        // menu flags
        _this.isHorizontal = false;
        _this.isRightOrBottom = false;
        // children
        _this.backgroundImg = null;
        _this.outterLayout = null;
        _this.thickness = 0;
        // optional properties
        if (isHorizontal && isHorizontal == true) {
            _this.axisNum = SIDEBAR_AXIS_X;
        }
        if (isRightOrBottom && isRightOrBottom == true) {
            _this.isRightOrBottom = true;
        }
        // set alignment
        _this.setAlignmentAndSize();
        // add children
        _this.addBackgroundImage();
        _this.addOutterLayout();
        return _this;
    }
    SideBarMenu.prototype.setAlignmentAndSize = function () {
        // horizontal alignment
        var horizontalAlign = GUI_CONST.ALIGN_H_CENTER;
        if (this.isHorizontal) {
            if (!this.isRightOrBottom) {
                horizontalAlign = GUI_CONST.ALIGN_H_LEFT;
            }
            // set size for horizontal sidebars
            else {
                horizontalAlign = GUI_CONST.ALIGN_H_RIGHT;
            }
            this.width = GUI_CONST.MENU_HEIGHT_SMALL;
            this.height = "100%";
        }
        this.horizontalAlignment = horizontalAlign;
        // vertical alignment
        var verticalAlign = GUI_CONST.ALIGN_V_CENTER;
        if (this.isVertical) {
            if (!this.isRightOrBottom) {
                verticalAlign = GUI_CONST.ALIGN_V_TOP;
            }
            else {
                verticalAlign = GUI_CONST.ALIGN_V_BOTTOM;
            }
            // set size for vertical ones
            this.width = GUI_CONST.WIDTH_FULL;
            this.height = GUI_CONST.MENU_HEIGHT_SMALL;
        }
        this.verticalAlignment = verticalAlign;
    };
    SideBarMenu.prototype.addBackgroundImage = function () {
        var bgImageId = this.name + "-bg";
        this.backgroundImg = new GUI.Image(bgImageId, GUI_CONST.BG_MENU_TOP);
        this.backgroundImg.horizontalAlignment = this.horizontalAlignment;
        this.backgroundImg.verticalAlignment = this.verticalAlignment;
        this.backgroundImg.width = this.width;
        this.backgroundImg.height = this.height;
        this.backgroundImg.stretch = GUI.Image.STRETCH_FILL;
        // add to menu element
        this.addControl(this.backgroundImg);
    };
    SideBarMenu.prototype.addOutterLayout = function () {
        var innerLayoutId = this.name + "-inner";
        this.outterLayout = new GUI.StackPanel(innerLayoutId);
        this.outterLayout.isVertical = this.innerLayoutIsVertical;
        // sizing
        var outterLayoutW = "50%";
        var outterLayoutH = GUI_CONST.MENU_HEIGHT_SMALL;
        if (this.isHorizontal) {
            outterLayoutW = this.width;
            outterLayoutH = "50%";
        }
        this.setSize(outterLayoutW, outterLayoutH);
        // inner layout aligment
        this.outterLayout.verticalAlignment = GUI_CONST.ALIGN_V_TOP;
        // add to menu element
        this.addControl(this.outterLayout);
    };
    Object.defineProperty(SideBarMenu.prototype, "isVertical", {
        /* SIDEBAR MENU GETTERS */
        get: function () { return !this.isHorizontal; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SideBarMenu.prototype, "innerLayoutIsVertical", {
        get: function () { return this.isHorizontal; },
        enumerable: false,
        configurable: true
    });
    return SideBarMenu;
}(AbstractMenu));
export { SideBarMenu };
/* == SIDE BAR MENU CONSTANTS == */
export var SIDEBAR_AXIS_X = 0; // left or right
export var SIDEBAR_AXIS_Y = 1; // top or bottom
//# sourceMappingURL=side-bar-menu.js.map