var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { CivicBuildingTypes, ProductionBuildingType } from "../entities/building/building-type";
import { AbstractManager } from "./abstract-manager";
var BuildingManager = /** @class */ (function (_super) {
    __extends(BuildingManager, _super);
    function BuildingManager() {
        var _this = _super.call(this, "Building") || this;
        _this._fileJson = null;
        return _this;
        // this.initializeBuildingTypes();
    }
    BuildingManager.prototype.initializeBuildingTypes = function () {
        this.log("initializing building types");
        // when resource types not yet loaded -> abort
        if (!globalThis.RESOURCE_TYPES) {
            this.error("cant initialize bld types; resource types not loaded");
            return;
        }
        // create production & civic bld types
        var resTypesCount = this.createProductionBldTypes();
        var civicTypesCount = this.createCivicBldTypes();
        this.log("".concat(resTypesCount, " production and ").concat(civicTypesCount, " civic building types loased"));
        this.onBldTypesInitialized();
    };
    BuildingManager.prototype.createStartingBldInCities = function () {
        for (var _i = 0, _a = globalThis.CITIES.getAll(); _i < _a.length; _i++) {
            var city = _a[_i];
            city.addStartingBuildings();
        }
    };
    /* BUILDING TYPE CREATION */
    BuildingManager.prototype.createProductionBldTypes = function () {
        var resTypesCount = 0;
        for (var _i = 0, _a = globalThis.TRADE.getResources(); _i < _a.length; _i++) {
            var res = _a[_i];
            globalThis.CONSTRUCTABLE.add(new ProductionBuildingType(res.id));
            resTypesCount += 1;
        }
        // returns the amount of created resource production bld types
        return resTypesCount;
    };
    BuildingManager.prototype.createCivicBldTypes = function () {
        var civicTypesCount = 0;
        for (var _i = 0, _a = CivicBuildingTypes.LIST; _i < _a.length; _i++) {
            var civicBldType = _a[_i];
            this.addAsConstructable(civicBldType);
            civicTypesCount += 1;
        }
        return civicTypesCount;
    };
    BuildingManager.prototype.addAsConstructable = function (bldType) {
        globalThis.CONSTRUCTABLE.add(bldType);
    };
    /* EVENT LISTENING */
    BuildingManager.prototype._onJsonLoaded = function (bldTypeJson) {
        this._fileJson = bldTypeJson;
        this.log("Building Types received");
        // initialize bld types
        this.initializeBuildingTypes();
    };
    BuildingManager.prototype.onBldTypesInitialized = function () {
        this.createStartingBldInCities();
    };
    return BuildingManager;
}(AbstractManager));
export { BuildingManager };
//# sourceMappingURL=building-manager.js.map