var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// models
import { HexDirection } from "../world/pos";
// manager
import { AbstractManager } from "./abstract-manager";
var moveKeyNums = {
    37: new HexDirection(HexDirection.WEST), 39: new HexDirection(HexDirection.EAST),
    36: new HexDirection(HexDirection.NORTHWEST), 33: new HexDirection(HexDirection.NORTHEAST),
    35: new HexDirection(HexDirection.SOUTHWEST), 34: new HexDirection(HexDirection.SOUTHEAST)
};
var moveKeyCodes = {
    "A": new HexDirection(HexDirection.WEST), "D": new HexDirection(HexDirection.EAST),
    "W": new HexDirection(HexDirection.NORTHWEST), "E": new HexDirection(HexDirection.NORTHEAST),
    "Z": new HexDirection(HexDirection.SOUTHWEST), "X": new HexDirection(HexDirection.SOUTHEAST)
};
var KEY_NEXT_TURN_BTN = "N";
var KEY_TOGGLE_INSPECTOR = "I";
var InputManager = /** @class */ (function (_super) {
    __extends(InputManager, _super);
    function InputManager() {
        var _this = _super.call(this, "Input") || this;
        _this.showingInspector = false;
        return _this;
    }
    InputManager.prototype.movePlayer = function (keyCode) {
        var dir = moveKeyCodes[keyCode];
        var dirStr = dir.dirStr;
        globalThis.PLAYER.moveInDir(dirStr);
        return true;
    };
    InputManager.prototype.endTurn = function () {
        if (!globalThis.TURNS) {
            this.error("turn manager not loaded");
            return false;
        }
        globalThis.TURNS.onEndTurnButton();
        return true;
    };
    InputManager.prototype.onKeyDown = function () {
    };
    InputManager.prototype.onKeyUp = function (keyCode) {
        if (!globalThis.MAP || !globalThis.PLAYER) {
            this.error("map not loaded");
            return false;
        }
        // move player
        if (keyCode in moveKeyCodes) {
            return this.movePlayer(keyCode);
            // next turn
        }
        else if (keyCode == KEY_NEXT_TURN_BTN) {
            return this.endTurn();
            // toggle inspector
        }
        else if (keyCode == KEY_TOGGLE_INSPECTOR) {
            return this.toggleInspector();
        }
    };
    InputManager.prototype.onMouseClick = function (event, pick) {
        // this.log(`${event} ${pick.pickedMesh.id}`);
        if (pick.pickedMesh) {
            this.onMeshClicked(pick.pickedMesh);
        }
    };
    InputManager.prototype.onMeshClicked = function (mesh) {
        if (globalThis.SELECTION) {
            globalThis.SELECTION.onMeshClicked(mesh);
        }
    };
    InputManager.prototype.toggleInspector = function () {
        this.showingInspector = !this.showingInspector;
        if (this.showingInspector) {
            globalThis.SCENE.debugLayer.show();
        }
        else {
            globalThis.SCENE.debugLayer.hide();
        }
        return true;
    };
    InputManager.prototype.toString = function () {
        return "<Input>";
    };
    return InputManager;
}(AbstractManager));
export { InputManager };
//# sourceMappingURL=input-manager.js.map