/* == TILE TERRAIN TYPES == */
var TerrainTypes = /** @class */ (function () {
    function TerrainTypes() {
    }
    Object.defineProperty(TerrainTypes, "GRASS", {
        get: function () { return "G"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "HILL", {
        get: function () { return "H"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "FOREST", {
        get: function () { return "F"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "STONE", {
        get: function () { return "O"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "MOUNTAIN", {
        get: function () { return "M"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "PEAK", {
        get: function () { return "P"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "CAVE", {
        get: function () { return "V"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "EARTH", {
        get: function () { return "E"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "WATER", {
        get: function () { return "W"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "DESERT", {
        get: function () { return "D"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "SAVANNAH", {
        get: function () { return "S"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "CITY", {
        get: function () { return "C"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "ARCTIC", {
        get: function () { return "A"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "BARREN", {
        get: function () { return "R"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "BRIDGE", {
        get: function () { return "B"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "LAVA", {
        get: function () { return "L"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "UNKNOWN", {
        get: function () { return "U"; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "LIST", {
        get: function () { return ["G", "H", "F", "O", "M", "P", "V", "E", "W", "D", "S", "C", "A", "R", "B", "L", "U"]; },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TerrainTypes, "LANDSCAPE", {
        get: function () { return ["G", "H", "F", "M", "P", "E", "D", "S", "A", "R", "L"]; },
        enumerable: false,
        configurable: true
    });
    TerrainTypes.heightOf = function (terrId) {
        switch (terrId) {
            case TerrainTypes.MOUNTAIN: return 2.1;
            case TerrainTypes.PEAK: return 2.6;
            case TerrainTypes.FOREST: return 0.9;
            case TerrainTypes.HILL: return 1.33;
            case TerrainTypes.SAVANNAH: return 0.65;
            // lower than default
            case TerrainTypes.DESERT: return 0.30;
            case TerrainTypes.BARREN: return 0.45;
            case TerrainTypes.WATER: return .01;
            case TerrainTypes.LAVA: return .02;
            case TerrainTypes.BRIDGE: return .22;
            default: return .50;
        }
    };
    TerrainTypes.topDiameterOf = function (terrId) {
        var HEXSIZE = 3;
        switch (terrId) {
            case TerrainTypes.UNKNOWN: return 0;
            default: return HEXSIZE;
        }
    };
    TerrainTypes.movementSpeedOn = function (terrId) {
        var specialMovementTerrains = { "F": .6, "H": 0.75, "M": .3, "P": 0, "D": .8, "R": .65, "S": .7, "A": .5 };
        if (terrId in specialMovementTerrains) {
            return specialMovementTerrains[terrId];
        }
        return 1;
    };
    return TerrainTypes;
}());
export { TerrainTypes };
/* == TERRAIN BLUEPRINT == */
var TerrainBlueprints = /** @class */ (function () {
    function TerrainBlueprints() {
        this._list = [];
    }
    TerrainBlueprints.prototype.add = function (bp) {
        this._list.push(bp);
    };
    TerrainBlueprints.prototype.get = function (terrainId) {
        var index = TerrainTypes.LIST.indexOf(terrainId);
        return this._list[index];
    };
    return TerrainBlueprints;
}());
export { TerrainBlueprints };
//# sourceMappingURL=tile-terrain.js.map