// world
import { WorldPos } from "../game/world/pos";
// babylon 
import * as BABYLON from 'babylonjs';
import { Strings } from "./strings";
/* == RANDOM INTEGER == */
var RandomInt = /** @class */ (function () {
    function RandomInt() {
    }
    RandomInt.below = function (belowNum) {
        return Math.floor(Math.random() * belowNum);
    };
    return RandomInt;
}());
export { RandomInt };
/* == RANDOM ARRAY ELEMENT == */
var RandomElement = /** @class */ (function () {
    function RandomElement() {
    }
    RandomElement.of = function (arr) {
        var index = RandomInt.below(arr.length);
        return arr[index];
    };
    return RandomElement;
}());
export { RandomElement };
/* == RANDOM DICE ROLL == */
var RandomDice = /** @class */ (function () {
    function RandomDice() {
    }
    RandomDice.roll = function (sides) {
        var result = RandomInt.below(sides);
        if (result == 0) {
            return true;
        }
        return false;
    };
    return RandomDice;
}());
export { RandomDice };
/* == RANDOM NAME == */
var RandomName = /** @class */ (function () {
    function RandomName() {
    }
    RandomName.from = function (prefixes, postfixes, capitalizeAfterSpace) {
        var rndPrefix = RandomElement.of(prefixes);
        var rndPostfix = RandomElement.of(postfixes);
        // capitalist first char in postpix (p.e. "Green H[!]ills")?
        if (capitalizeAfterSpace && rndPostfix.charAt(0) == " ") {
            rndPostfix = Strings.capitalizeFirst(rndPostfix);
        }
        return rndPrefix + rndPostfix;
    };
    return RandomName;
}());
export { RandomName };
/* == RANDOM WORLD POSITION == */
var RandomWorldPos = /** @class */ (function () {
    function RandomWorldPos() {
    }
    RandomWorldPos.around = function (centerPos, radius, excludeCenter) {
        // calculate boundary positions
        var topleft = new WorldPos(centerPos.x - radius, centerPos.z - radius);
        var btmright = new WorldPos(centerPos.x + radius, centerPos.z + radius);
        var positionsInRadius = [];
        // add every position between boundaries to array ..
        for (var z = topleft.z; z <= btmright.z; z++) {
            for (var x = topleft.x; x <= btmright.x; x++) {
                var currentPos = new WorldPos(x, z);
                var isCenterPos = currentPos.x == centerPos.x && currentPos.z == centerPos.z;
                var isExcluded = isCenterPos && excludeCenter;
                // .. if they're not the center and excludeCenter is true
                if (!isExcluded) {
                    positionsInRadius.push(currentPos);
                }
            }
        }
        // choose & return a random element from the position array
        var chosenPos = RandomElement.of(positionsInRadius);
        return chosenPos;
    };
    return RandomWorldPos;
}());
export { RandomWorldPos };
var RandomRotation = /** @class */ (function () {
    function RandomRotation() {
    }
    RandomRotation.inDeg = function (no90Lock) {
        var angleDeg = RandomInt.below(4) * 90;
        if (no90Lock && no90Lock == true) {
            angleDeg = RandomInt.below(360);
        }
        return angleDeg;
    };
    RandomRotation.inRad = function (no90Lock) {
        var angleDeg = RandomRotation.inDeg(no90Lock);
        return BABYLON.Tools.ToRadians(angleDeg);
    };
    RandomRotation.onMesh = function (mesh, no90Lock) {
        var rndRad = RandomRotation.inRad(no90Lock);
        mesh.rotation.y = rndRad;
        return mesh;
    };
    return RandomRotation;
}());
export { RandomRotation };
//# sourceMappingURL=random.js.map