// common
import { Loggable } from "../../../../common/log";
// events
import { BaseEventListener, IBaseEvent } from "../../../../common/events";
import * as EV from "../../../game-events";
// entities
import { City } from "../../city/city";
import { IFaction } from "../faction";

export interface IFactionAi {
    faction: IFaction;
}

export class FactionAi extends BaseEventListener implements IFactionAi {
    faction: IFaction;

    constructor(forFaction: IFaction) {
        super("FactionAi");
        this.faction = forFaction;
    }

    public onEvent(ev: IBaseEvent): void {
        if ( ev.id == EV.ID_TURN_FINISHED ) {
            this.onTurnFinished();
        }
    }

    private onTurnFinished() {

    }
    
}