// common
import { DawnbringerPalette } from "../../../common/colors";
// events
import { IBaseEvent } from "../../../common/events";
import * as EV from "../../game-events";
// entities
import { UnitArmy } from "../../entities/unit/army/army";
// gui
import * as GUI_CONST from '../common/constants';
import { EmptyDialog, IDialog } from "./common/base-dialog";
// babylon
import * as GUI from 'babylonjs-gui';
import { Unit } from "../../entities/unit/unit";

export class SingleArmyDialog extends EmptyDialog {
    army: UnitArmy;

    constructor(army: UnitArmy) {
        super(DIAG_ARMY, true, "Army", [], false, false, army.ownerFaction);
        this.army = army;
    }

    addCustomContent(): void {
        this.addNewDataRow("Name", this.army.name, "name");
        this.addNewDataRow("Owner", this.ownerFactionName, "empire");
        // show units
        this.showUnitList();
    }

    showUnitList(): void {
        this.addNewSectionHeader("Units");
        for (const unit of this.army.units) {
            this.showSingleUnitRow(unit);
        }
    }

    private showSingleUnitRow(unit: Unit) {
        this.addNewDataRow("", unit.type.name, "might");
    }

    get ownerFactionName(): string {
        return this.army.ownerFaction.name;
    }
}

export const DIAG_ARMY = "diag-army";
